// Stencil
import { h, Component, Prop } from '@stencil/core';
export class ContentIcon {
    constructor() {
        // Props
        this.iconName = null;
        this.iconBgColor = '#e6e6e6';
        this.iconColor = 'dark-tint';
        this.displayImage = false;
        this.image = '';
        this.displaySeparation = true;
        this.pointBgColor = '#bbf0f9';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'content-icon-container' },
            h("div", { class: 'icon-container', style: {
                    backgroundColor: this.iconBgColor,
                    backgroundImage: this.displayImage ? 'url(' + this.image + ')' : '',
                    border: this.displayImage ? '3px solid ' + this.pointBgColor : '',
                    width: this.displayImage ? '36px' : '42px',
                    height: this.displayImage ? '36px' : '42px'
                } }, this.displayImage
                ? ''
                : h("span", null,
                    h("ion-icon", { name: this.iconName, color: this.iconColor }))),
            h("div", { class: 'separation-container', style: { opacity: this.displaySeparation ? '1' : '0' } }),
            h("div", { class: 'point-container', style: { backgroundColor: this.pointBgColor, opacity: this.displaySeparation ? '1' : '0' } })));
    }
    static get is() { return "content-icon"; }
    static get originalStyleUrls() { return {
        "$": ["content-icon.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["content-icon.css"]
    }; }
    static get properties() { return {
        "iconName": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "icon-name",
            "reflect": false,
            "defaultValue": "null"
        },
        "iconBgColor": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "icon-bg-color",
            "reflect": false,
            "defaultValue": "'#e6e6e6'"
        },
        "iconColor": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "icon-color",
            "reflect": false,
            "defaultValue": "'dark-tint'"
        },
        "displayImage": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "display-image",
            "reflect": false,
            "defaultValue": "false"
        },
        "image": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "image",
            "reflect": false,
            "defaultValue": "''"
        },
        "displaySeparation": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "display-separation",
            "reflect": false,
            "defaultValue": "true"
        },
        "pointBgColor": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "point-bg-color",
            "reflect": false,
            "defaultValue": "'#bbf0f9'"
        }
    }; }
}
