// Stencil
import { h, Component, Prop } from '@stencil/core';
export class ExpertIntroContent {
    constructor() {
        // Properties
        this.name = "Expert Introduction";
        this.expertImage = [];
        this.expertName = '';
        this.expertShortDescription = '';
        this.audioTitle = '';
        this.audioSource = [];
        this.script = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("audio-content", { name: this.name, image: this.expertImage, audioTitle: this.audioTitle, audioSource: this.audioSource, script: this.script },
            h("span", { slot: "audio-text" },
                h("h3", { class: 'expert-title' },
                    h("span", { class: 'colored-background' }, this.expertName)),
                h("p", { class: 'expert-subtitle' },
                    h("span", { class: 'colored-background' }, this.expertShortDescription)))));
    }
    static get is() { return "expert-intro-content"; }
    static get originalStyleUrls() { return {
        "$": ["expert-intro-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["expert-intro-content.css"]
    }; }
    static get properties() { return {
        "name": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false,
            "defaultValue": "\"Expert Introduction\""
        },
        "expertImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "expertName": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "expert-name",
            "reflect": false,
            "defaultValue": "''"
        },
        "expertShortDescription": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "expert-short-description",
            "reflect": false,
            "defaultValue": "''"
        },
        "audioTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "audio-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "audioSource": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "script": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "script",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
