// Stencil
import { h, Component, Prop } from '@stencil/core';
export class ExpertPointContent {
    constructor() {
        // Props
        this.name = 'Expert point';
        this.contentTitle = '';
        this.description = '';
        this.expertThumbnail = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("div", { class: 'main-container' },
                h("div", { class: 'header-container' },
                    h("div", { class: 'image-container', style: {
                            backgroundImage: 'url(' + this.expertThumbnail + ')'
                        } }),
                    h("div", { class: 'separation' }),
                    h("p", { class: 'header-text' }, this.name)),
                h("div", { class: 'content-container' },
                    h("p", { class: 'title' }, this.contentTitle),
                    h("div", { class: 'description-container' },
                        h("p", { class: 'description' }, this.description))))));
    }
    static get is() { return "expert-point-content"; }
    static get originalStyleUrls() { return {
        "$": ["expert-point-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["expert-point-content.css"]
    }; }
    static get properties() { return {
        "name": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false,
            "defaultValue": "'Expert point'"
        },
        "contentTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "content-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "description": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description",
            "reflect": false,
            "defaultValue": "''"
        },
        "expertThumbnail": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "expert-thumbnail",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
