// Stencil
import { h, Component, Prop } from '@stencil/core';
export class MagicNumberContent {
    constructor() {
        // Props
        this.name = '';
        this.fact = '';
        this.description = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("div", { class: 'main-container' },
                h("div", { class: 'subcontainer' },
                    h("div", { class: 'header-container' },
                        h("p", { class: 'header-text' }, this.name)),
                    h("div", { class: 'content-container' },
                        h("p", { class: 'number' },
                            this.number,
                            "!"),
                        h("p", { class: 'fact' }, this.fact),
                        h("p", { class: 'description' }, this.description))))));
    }
    static get is() { return "magic-number-content"; }
    static get originalStyleUrls() { return {
        "$": ["magic-number-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["magic-number-content.css"]
    }; }
    static get properties() { return {
        "name": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false,
            "defaultValue": "''"
        },
        "number": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "number",
            "reflect": false
        },
        "fact": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "fact",
            "reflect": false,
            "defaultValue": "''"
        },
        "description": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
