// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MediaTool } from '../../../tools/media-tool';
export class QuoteContent {
    constructor() {
        // Props
        this.name = "Quote";
        this.quote = '';
        this.author = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'main-container' },
            h("div", { class: 'header-container' },
                h("p", { class: 'header-text' }, this.name)),
            h("div", { class: 'quote-background-container', style: { backgroundImage: 'url(' + MediaTool.imageL(this.backgroundImage) + ')' } },
                h("div", { class: 'quote-content-subcontainer' },
                    h("div", { class: 'citation-container' },
                        h("p", { class: 'quote title' },
                            " ",
                            h("span", { class: 'quote-sign' }, "\u201C\u00A0"),
                            this.quote,
                            h("span", { class: 'quote-sign' }, "\u00A0\u201D")),
                        h("p", { class: 'author-text' }, this.author))))));
    }
    static get is() { return "quote-content"; }
    static get originalStyleUrls() { return {
        "$": ["quote-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["quote-content.css"]
    }; }
    static get properties() { return {
        "name": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "name",
            "reflect": false,
            "defaultValue": "\"Quote\""
        },
        "backgroundImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        },
        "quote": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "quote",
            "reflect": false,
            "defaultValue": "''"
        },
        "author": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "author",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
