// Stencil
import { h, Component, Prop } from '@stencil/core';
export class FeatureIconElement {
    constructor() {
        // Props
        this.featureTitle = '';
        this.featureText = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'full-container' },
            h("div", { class: 'icon-container' },
                h("slot", { name: "icon" })),
            h("div", { class: 'text-container' },
                h("h5", null,
                    h("span", null, this.featureTitle)),
                h("p", null, this.featureText))));
    }
    static get is() { return "feature-icon-element"; }
    static get originalStyleUrls() { return {
        "$": ["feature-icon-element.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["feature-icon-element.css"]
    }; }
    static get properties() { return {
        "featureTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "feature-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "featureText": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "feature-text",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
