// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MediaTool } from '../../../tools/media-tool';
export class FeatureImageElement {
    constructor() {
        // Props
        this.image = [];
        this.hashtag = '';
        this.featureTitle = '';
        this.featureText = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'feature-image-container' },
            h("div", { style: { backgroundImage: 'url(' + MediaTool.imageL(this.image) + ')' }, class: 'image-container' }),
            h("div", { class: 'text-container' },
                h("p", { class: 'hashtag-text' },
                    "# ",
                    this.hashtag),
                h("div", { class: 'title-container' },
                    h("h5", null,
                        h("span", null, this.featureTitle))),
                h("p", null, this.featureText))));
    }
    static get is() { return "feature-image-element"; }
    static get originalStyleUrls() { return {
        "$": ["feature-image-element.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["feature-image-element.css"]
    }; }
    static get properties() { return {
        "image": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "hashtag": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "hashtag",
            "reflect": false,
            "defaultValue": "''"
        },
        "featureTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "feature-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "featureText": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "feature-text",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
