// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MarkdownTool } from '../../../tools/markdown-tool';
export class GeneralMarkdownContent {
    constructor() {
        this.content = "Content goes here !";
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return ([
            h("image-header", { headerTitle: this.headerTitle, headerSubtitle: this.headerSubtitle, headerImage: this.headerImage }),
            h("div", { class: "content-div", innerHTML: MarkdownTool.render(this.content) })
        ]);
    }
    static get is() { return "general-markdown-content"; }
    static get originalStyleUrls() { return {
        "$": ["general-markdown-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["general-markdown-content.css"]
    }; }
    static get properties() { return {
        "headerTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-title",
            "reflect": false
        },
        "headerSubtitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-subtitle",
            "reflect": false
        },
        "headerImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement",
                "resolved": "MediaElement",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        },
        "content": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "content",
            "reflect": false,
            "defaultValue": "\"Content goes here !\""
        }
    }; }
}
