// Stencil
import { h, Component, Prop } from '@stencil/core';
export class GeneralTopFactsContent {
    constructor() {
        this.headerVisible = true;
        this.facts = [];
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            this.headerVisible
                && h("image-header", { headerTitle: this.headerTitle, headerSubtitle: this.headerSubtitle, headerImage: this.headerImage }),
            h("div", { class: 'content-div' },
                this.facts.map((fact, i) => h("span", null,
                    h("p", { class: 'fact-index' }, i + 1),
                    h("p", { class: 'fact-title' }, fact.title),
                    h("p", { class: 'fact-description' }, fact.description))),
                h("div", { class: "bottom-margin-container" }))));
    }
    static get is() { return "general-top-facts-content"; }
    static get originalStyleUrls() { return {
        "$": ["general-top-facts-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["general-top-facts-content.css"]
    }; }
    static get properties() { return {
        "headerTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-title",
            "reflect": false
        },
        "headerSubtitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-subtitle",
            "reflect": false
        },
        "headerImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement",
                "resolved": "MediaElement",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        },
        "headerVisible": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-visible",
            "reflect": false,
            "defaultValue": "true"
        },
        "facts": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "Fact[]",
                "resolved": "Fact[]",
                "references": {
                    "Fact": {
                        "location": "import",
                        "path": "./Fact"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        }
    }; }
}
