// Stencil
import { h, Component, Prop } from '@stencil/core';
export class TilesContent {
    constructor() {
        // Props
        this.headerTitle = '';
        this.headerSubtitle = '';
        this.headerVisible = true;
        this.elements = [];
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'tiles-div' },
            this.headerVisible && h("div", { class: 'header-div' },
                h("span", { class: 'header-span' },
                    h("h3", { class: 'header-title' }, this.headerTitle),
                    h("span", { class: 'header-subtitle' }, this.headerSubtitle))),
            h("ion-grid", null, this.elements.map((element, index) => h("flip-card-row", { row: element, index: index, showBackFlipButton: false, cardToText: (index + 1) % 2 == 1 ? 'right' : 'left' })))));
    }
    static get is() { return "tiles-content"; }
    static get originalStyleUrls() { return {
        "$": ["tiles-content.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["tiles-content.css"]
    }; }
    static get properties() { return {
        "headerTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerSubtitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-subtitle",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerVisible": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-visible",
            "reflect": false,
            "defaultValue": "true"
        },
        "elements": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "Row[]",
                "resolved": "Row[]",
                "references": {
                    "Row": {
                        "location": "import",
                        "path": "../../generics/flip-card-row/Row"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        }
    }; }
}
