// Stencil
import { h, Component, Prop } from '@stencil/core';
export class TopElement {
    constructor() {
        // Props
        this.topTitle = '';
        this.topDescription = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("p", { class: 'list-index' },
                h("span", null,
                    this.index < 9
                        ? h("span", null, "0")
                        : '',
                    this.index)),
            h("h4", { class: 'list-title' }, this.topTitle),
            h("p", { class: 'list-text' }, this.topDescription)));
    }
    static get is() { return "top-element"; }
    static get originalStyleUrls() { return {
        "$": ["top-element.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["top-element.css"]
    }; }
    static get properties() { return {
        "topTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "top-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "topDescription": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "top-description",
            "reflect": false,
            "defaultValue": "''"
        },
        "index": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "index",
            "reflect": false
        }
    }; }
}
