// Ionic
import '@ionic/core';
// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MediaTool } from '../../../tools/media-tool';
export class FullImageHeader {
    constructor() {
        // Props
        this.headerTitle = '';
        this.headerSubtitle = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'header-container' },
            h("div", { style: { 'background-image': 'url(' + MediaTool.imageXXL(this.headerImage) + ')' }, class: 'image-container' }),
            h("div", { class: "title-container" },
                h("h1", { class: "header-title" },
                    h("span", null, this.headerTitle)),
                h("p", { class: "header-subtitle" },
                    h("span", null, this.headerSubtitle)))));
    }
    static get is() { return "full-image-header"; }
    static get originalStyleUrls() { return {
        "$": ["full-image-header.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["full-image-header.css"]
    }; }
    static get properties() { return {
        "headerTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerSubtitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-subtitle",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement",
                "resolved": "MediaElement",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        }
    }; }
}
