// Ionic
import '@ionic/core';
// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MediaTool } from '../../../tools/media-tool';
export class ImageHeader {
    constructor() {
        // Props
        this.headerTitle = '';
        this.headerSubtitle = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        const imageOverlay = this.headerImage ? this.headerImage.overlay : 50;
        return (h("div", { class: 'main-container', style: { backgroundImage: 'url(' + MediaTool.imageL(this.headerImage) + ')', backgroundColor: 'rgba(0, 0, 0, ' + imageOverlay / 100 + ')' } },
            h("span", { class: 'content-container' },
                h("h3", { class: "slide-title" },
                    " ",
                    this.headerTitle,
                    " "),
                h("p", { class: "slide-subtitle" },
                    " ",
                    this.headerSubtitle,
                    " "))));
    }
    static get is() { return "image-header"; }
    static get originalStyleUrls() { return {
        "$": ["image-header.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["image-header.css"]
    }; }
    static get properties() { return {
        "headerTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerSubtitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "header-subtitle",
            "reflect": false,
            "defaultValue": "''"
        },
        "headerImage": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement",
                "resolved": "MediaElement",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            }
        }
    }; }
}
