// Stencil
import { h, Component, Prop } from '@stencil/core';
export class MetroIndication {
    constructor() {
        // Props
        this.transportInfo = [];
        this.exitPrefix = '';
        this.city = 'paris';
        this.colorMode = 'light'; // 'dark'
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: "indication-container" }, this.transportInfo.map(info => h("span", { class: "indication-content", style: { color: this.colorMode === 'light' ? 'white' : 'black' } },
            h("p", null, "\u2022"),
            h("p", null, info.name),
            h("span", { class: "line-icon-container" }, info.lines.map(line => h("ion-icon", { src: line.getLineIcon(this.city), class: 'line-icon' }))),
            h("p", null,
                this.exitPrefix,
                info.exit)))));
    }
    static get is() { return "metro-indication"; }
    static get originalStyleUrls() { return {
        "$": ["metro-indication.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["metro-indication.css"]
    }; }
    static get properties() { return {
        "transportInfo": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "TransportIndication[]",
                "resolved": "TransportIndication[]",
                "references": {
                    "TransportIndication": {
                        "location": "import",
                        "path": "../../../models/transport/transport-indication"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "exitPrefix": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "exit-prefix",
            "reflect": false,
            "defaultValue": "''"
        },
        "city": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "city",
            "reflect": false,
            "defaultValue": "'paris'"
        },
        "colorMode": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "color-mode",
            "reflect": false,
            "defaultValue": "'light'"
        }
    }; }
}
