// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MarkdownTool } from '../../../tools/markdown-tool';
export class SloganText {
    constructor() {
        // Props
        this.slogan = '';
        this.sloganColor = '#b9b029';
        this.text = 'Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt.';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return ([
            h("div", { class: 'full-container' },
                h("div", { class: 'slogan-container', style: { color: this.sloganColor } }, this.slogan),
                h("div", { class: 'text-container', innerHTML: MarkdownTool.render(this.text) }))
        ]);
    }
    static get is() { return "slogan-text"; }
    static get originalStyleUrls() { return {
        "$": ["slogan-text.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["slogan-text.css"]
    }; }
    static get properties() { return {
        "slogan": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "slogan",
            "reflect": false,
            "defaultValue": "''"
        },
        "sloganColor": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "slogan-color",
            "reflect": false,
            "defaultValue": "'#b9b029'"
        },
        "text": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "text",
            "reflect": false,
            "defaultValue": "'Sed ut perspiciatis unde omnis iste natus error sit voluptatem accusantium doloremque laudantium, totam rem aperiam, eaque ipsa quae ab illo inventore veritatis et quasi architecto beatae vitae dicta sunt explicabo. Nemo enim ipsam voluptatem quia voluptas sit aspernatur aut odit aut fugit, sed quia consequuntur magni dolores eos qui ratione voluptatem sequi nesciunt.'"
        }
    }; }
}
