// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MarkdownTool } from '../../../../tools/markdown-tool';
// Constants
const MAX_PLACE_DESCRIPTION_LENGTH = 200;
export class PlacePresentationDescription {
    constructor() {
        // Props
        this.description = '';
        this.descriptionTitle = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("h4", { class: 'place-section-title' }, this.descriptionTitle),
            h("div", { class: 'place-description', innerHTML: MarkdownTool.render(this.description) })));
    }
    static get is() { return "place-presentation-description"; }
    static get originalStyleUrls() { return {
        "$": ["place-presentation-description.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["place-presentation-description.css"]
    }; }
    static get properties() { return {
        "description": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description",
            "reflect": false,
            "defaultValue": "''"
        },
        "descriptionTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description-title",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
