// Stencil
import { h, Component, Prop } from '@stencil/core';
export class PlacePresentationInfo {
    constructor() {
        // Props
        this.address = null;
        this.metroStation = null;
        this.phone = null;
        this.website = null;
        this.infoTitle = '';
        this.addressLabel = '';
        this.metroStationLabel = '';
        this.phoneLabel = '';
        this.websiteLabel = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("h4", { class: 'place-section-title' }, this.infoTitle),
            h("div", { class: "info-container" },
                this.address
                    ? h("div", { class: "info" },
                        h("p", { class: 'info-title' }, this.addressLabel),
                        h("p", { class: 'info-value' }, this.address))
                    : '',
                this.metroStation
                    ? h("div", { class: "info" },
                        h("p", { class: 'info-title' }, this.metroStationLabel),
                        h("p", { class: 'info-value' }, this.metroStation))
                    : '',
                this.phone
                    ? h("div", { class: "info" },
                        h("p", { class: 'info-title' }, this.phoneLabel),
                        h("p", { class: 'info-value' }, this.phone))
                    : '',
                this.website
                    ? h("div", { class: "info" },
                        h("p", { class: 'info-title' }, this.websiteLabel),
                        h("a", { class: 'info-value', href: 'https://' + this.website }, this.website))
                    : '')));
    }
    static get is() { return "place-presentation-info"; }
    static get originalStyleUrls() { return {
        "$": ["place-presentation-info.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["place-presentation-info.css"]
    }; }
    static get properties() { return {
        "address": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "address",
            "reflect": false,
            "defaultValue": "null"
        },
        "metroStation": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "metro-station",
            "reflect": false,
            "defaultValue": "null"
        },
        "phone": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "phone",
            "reflect": false,
            "defaultValue": "null"
        },
        "website": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "website",
            "reflect": false,
            "defaultValue": "null"
        },
        "infoTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "info-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "addressLabel": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "address-label",
            "reflect": false,
            "defaultValue": "''"
        },
        "metroStationLabel": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "metro-station-label",
            "reflect": false,
            "defaultValue": "''"
        },
        "phoneLabel": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "phone-label",
            "reflect": false,
            "defaultValue": "''"
        },
        "websiteLabel": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "website-label",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
