// Stencil
import { h, Component, Prop } from '@stencil/core';
export class PlacePresentationItems {
    constructor() {
        // Props
        this.famousItems = [];
        this.itemsTitle = '';
        this.seeMoreButton = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("h4", { class: 'place-section-title' }, this.itemsTitle),
            h("div", { class: "item-list-container" }, this.famousItems.map((item, index) => h("li", null, item)))));
    }
    static get is() { return "place-presentation-items"; }
    static get originalStyleUrls() { return {
        "$": ["place-presentation-items.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["place-presentation-items.css"]
    }; }
    static get properties() { return {
        "famousItems": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "String[]",
                "resolved": "String[]",
                "references": {
                    "String": {
                        "location": "global"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "itemsTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "items-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "seeMoreButton": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "see-more-button",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
