// Stencil
import { h, Component, Prop } from '@stencil/core';
export class PlacePresentationPhotoGallery {
    constructor() {
        // Props
        this.images = [];
        this.photoGalleryTitle = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", null,
            h("h4", { class: 'place-section-title' }, this.photoGalleryTitle),
            h("div", { class: "gallery-container" },
                h("image-gallery", { colorMode: 'light', images: this.images }))));
    }
    static get is() { return "place-presentation-photo-gallery"; }
    static get originalStyleUrls() { return {
        "$": ["place-presentation-photo-gallery.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["place-presentation-photo-gallery.css"]
    }; }
    static get properties() { return {
        "images": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "photoGalleryTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "photo-gallery-title",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
