// Stencil
import { h, Component, Prop } from '@stencil/core';
// Tools
import { MarkdownTool } from '../../../../tools/markdown-tool';
// Constants
const MAX_COMPOSITION_DESCRIPTION_LENGTH = 200;
export class CompositionDescription {
    constructor() {
        // Props
        this.compositionTitle = '';
        this.description = '';
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("section", { id: 'info' },
            h("div", { class: 'composition-description-container' },
                h("h4", { class: 'composition-section-title' }, this.compositionTitle),
                h("div", { class: 'composition-description-text', innerHTML: MarkdownTool.render(this.description) }))));
    }
    static get is() { return "composition-description"; }
    static get originalStyleUrls() { return {
        "$": ["composition-description.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["composition-description.css"]
    }; }
    static get properties() { return {
        "compositionTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "composition-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "description": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "description",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
}
