// Stencil
import { h, Component, Event, Prop } from '@stencil/core';
export class TourMapHyperlink {
    constructor() {
        // Props
        this.tourMapTitle = '';
        this.locationOverview = [];
    }
    ////////////////////////////////////////////////////////////////
    // User Interactions
    ////////////////////////////////////////////////////////////////
    /**
     * Click on the image
     */
    onButtonClick() {
        this.buttonClicked.emit();
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("section", { id: 'details' },
            h("div", { class: 'statistics-container ion-activatable' },
                h("h4", { class: 'composition-section-title' }, this.tourMapTitle),
                h("div", { style: { 'background-image': 'url(' + this.locationOverview[0].media + ')' }, class: 'map-image', onClick: () => this.onButtonClick() },
                    h("ion-ripple-effect", null)))));
    }
    static get is() { return "tour-map-hyperlink"; }
    static get originalStyleUrls() { return {
        "$": ["tour-map-hyperlink.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["tour-map-hyperlink.css"]
    }; }
    static get properties() { return {
        "tourMapTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "tour-map-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "locationOverview": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        }
    }; }
    static get events() { return [{
            "method": "buttonClicked",
            "name": "buttonClicked",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            }
        }]; }
}
