// Stencil
import { h, Component, Prop } from '@stencil/core';
export class TourPhotoGallery {
    constructor() {
        // Props
        this.galleryTitle = '';
        this.images = [];
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: "tour-photo-gallery-container" },
            h("h4", { class: 'composition-section-title' }, this.galleryTitle),
            h("div", { class: "gallery-container" },
                h("image-gallery", { colorMode: 'light', isWeb: this.isWeb, images: this.images }))));
    }
    static get is() { return "tour-photo-gallery"; }
    static get originalStyleUrls() { return {
        "$": ["tour-photo-gallery.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["tour-photo-gallery.css"]
    }; }
    static get properties() { return {
        "galleryTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "gallery-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "images": {
            "type": "unknown",
            "mutable": false,
            "complexType": {
                "original": "MediaElement[]",
                "resolved": "MediaElement[]",
                "references": {
                    "MediaElement": {
                        "location": "import",
                        "path": "../../../../models/media/media-model"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "defaultValue": "[]"
        },
        "isWeb": {
            "type": "boolean",
            "mutable": true,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "is-web",
            "reflect": false
        }
    }; }
}
