// Stencil
import { h, Component, Prop, Event } from '@stencil/core';
export class LargeTourSnap {
    constructor() {
        // Props
        this.showImage = false;
        this.image = '';
        this.tourTitle = null;
        this.overlay = 20;
        this.duration = '';
    }
    ////////////////////////////////////////////////////////////////
    // User Interactions
    ////////////////////////////////////////////////////////////////
    /**
     * Click on the card
     */
    onClick() {
        this.dosClick.emit();
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: "tour-snap-container ion-activatable" },
            h("div", { class: 'tour-snap-subcontainer', style: {
                    backgroundImage: this.showImage ? 'url(' + this.image + ')' : '',
                    backgroundColor: 'rgba(0,0,0,' + this.overlay / 100 + ')'
                }, onClick: () => this.onClick() },
                h("div", { class: "tour-snap-header" },
                    h("span", { class: "tour-duration" },
                        h("p", null, this.duration)),
                    h("div", { class: 'price-container' },
                        h("p", { class: 'price-text' }, this.price))),
                h("div", { class: 'tour-title-container' },
                    h("h3", { class: 'tour-title' }, this.tourTitle))),
            h("ion-ripple-effect", null)));
    }
    static get is() { return "large-tour-snap"; }
    static get originalStyleUrls() { return {
        "$": ["large-tour-snap.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["large-tour-snap.css"]
    }; }
    static get properties() { return {
        "showImage": {
            "type": "boolean",
            "mutable": true,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "show-image",
            "reflect": false,
            "defaultValue": "false"
        },
        "image": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "image",
            "reflect": false,
            "defaultValue": "''"
        },
        "tourTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "tour-title",
            "reflect": false,
            "defaultValue": "null"
        },
        "price": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "price",
            "reflect": false
        },
        "overlay": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "overlay",
            "reflect": false,
            "defaultValue": "20"
        },
        "duration": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "duration",
            "reflect": false,
            "defaultValue": "''"
        }
    }; }
    static get events() { return [{
            "method": "dosClick",
            "name": "dosClick",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "void",
                "resolved": "void",
                "references": {}
            }
        }]; }
}
