// Stencil
import { h, Component, Prop, Event } from '@stencil/core';
export class ListSnap {
    constructor() {
        // Props
        this.showImage = false;
        this.image = '';
        this.listTitle = '';
        this.placeCount = 1;
        this.overlay = 20;
    }
    ////////////////////////////////////////////////////////////////
    // User Interactions
    ////////////////////////////////////////////////////////////////
    /**
     * Click on the card
     */
    onClick() {
        this.dosClick.emit();
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'list-main-container' },
            h("div", { class: 'list-subcontainer ion-activatable' },
                h("ion-button", { color: 'tertiary', class: 'view-button', onClick: () => this.onClick() },
                    h("ion-icon", { name: 'eye', size: 'small', color: 'light', class: 'view-button-icon' })),
                h("ion-ripple-effect", null),
                h("div", { class: "image-container", style: {
                        backgroundImage: this.showImage ? 'url(' + this.image + ')' : '',
                        backgroundColor: 'rgba(0,0,0,' + this.overlay / 100 + ')'
                    }, onClick: () => this.onClick() }),
                h("div", { class: "text-container", onClick: () => this.onClick() },
                    h("h3", { class: 'list-title' }, this.listTitle)),
                h("p", { class: 'top-text' },
                    "TOP ",
                    this.placeCount))));
    }
    static get is() { return "list-snap"; }
    static get originalStyleUrls() { return {
        "$": ["list-snap.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["list-snap.css"]
    }; }
    static get properties() { return {
        "showImage": {
            "type": "boolean",
            "mutable": true,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "show-image",
            "reflect": false,
            "defaultValue": "false"
        },
        "image": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "image",
            "reflect": false,
            "defaultValue": "''"
        },
        "listTitle": {
            "type": "string",
            "mutable": true,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "list-title",
            "reflect": false,
            "defaultValue": "''"
        },
        "placeCount": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "place-count",
            "reflect": false,
            "defaultValue": "1"
        },
        "overlay": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "overlay",
            "reflect": false,
            "defaultValue": "20"
        }
    }; }
    static get events() { return [{
            "method": "dosClick",
            "name": "dosClick",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "void",
                "resolved": "void",
                "references": {}
            }
        }]; }
}
