// Stencil
import { h, Component, Prop, Event } from '@stencil/core';
export class TourSnap {
    constructor() {
        // Props
        this.image = '';
        this.tourTitle = null;
        this.price = null;
        this.currency = '€';
        this.currencyBefore = false;
        this.category = '';
        this.overlay = 20;
    }
    ////////////////////////////////////////////////////////////////
    // User Interactions
    ////////////////////////////////////////////////////////////////
    /**
     * Click on the card
     */
    onClick() {
        this.dosClick.emit();
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'tour-snap-container ion-activatable', style: {
                backgroundImage: 'url(' + this.image + ')',
                backgroundColor: 'rgba(0,0,0,' + this.overlay / 100 + ')'
            }, onClick: () => this.onClick() },
            h("ion-ripple-effect", null),
            h("p", { class: 'category-text' },
                "# ",
                this.category),
            this.price
                ? h("span", null, this.currencyBefore
                    ? h("p", { class: 'price-text' },
                        this.currency,
                        " ",
                        this.price)
                    : h("p", { class: 'price-text' },
                        this.price,
                        " ",
                        this.currency))
                : '',
            h("h3", { class: 'tour-title' }, this.tourTitle)));
    }
    static get is() { return "tour-snap"; }
    static get originalStyleUrls() { return {
        "$": ["tour-snap.scss"]
    }; }
    static get styleUrls() { return {
        "$": ["tour-snap.css"]
    }; }
    static get properties() { return {
        "image": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "image",
            "reflect": false,
            "defaultValue": "''"
        },
        "tourTitle": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "tour-title",
            "reflect": false,
            "defaultValue": "null"
        },
        "price": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "price",
            "reflect": false,
            "defaultValue": "null"
        },
        "currency": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "currency",
            "reflect": false,
            "defaultValue": "'\u20AC'"
        },
        "currencyBefore": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "currency-before",
            "reflect": false,
            "defaultValue": "false"
        },
        "category": {
            "type": "string",
            "mutable": false,
            "complexType": {
                "original": "string",
                "resolved": "string",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "category",
            "reflect": false,
            "defaultValue": "''"
        },
        "overlay": {
            "type": "number",
            "mutable": false,
            "complexType": {
                "original": "number",
                "resolved": "number",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "overlay",
            "reflect": false,
            "defaultValue": "20"
        }
    }; }
    static get events() { return [{
            "method": "dosClick",
            "name": "dosClick",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "void",
                "resolved": "void",
                "references": {}
            }
        }]; }
}
