import { r as registerInstance, c as createEvent, i as readTask, h, H as Host, e as getElement } from './index-9bc5455c.js';
import { g as getIonMode } from './ionic-global-54ea523e.js';
import { d as debounceEvent, r as raf, f as findItemLabel } from './helpers-29d709d1.js';
import { c as createColorClasses } from './theme-1706d6ff.js';

const textareaIosCss = ".sc-ion-textarea-ios-h{--background:initial;--color:initial;--placeholder-color:initial;--placeholder-font-style:initial;--placeholder-font-weight:initial;--placeholder-opacity:.5;--padding-top:0;--padding-end:0;--padding-bottom:0;--padding-start:0;--border-radius:0;display:block;position:relative;-ms-flex:1;flex:1;width:100%;background:var(--background);color:var(--color);font-family:var(--ion-font-family, inherit);white-space:pre-wrap;z-index:2;-webkit-box-sizing:border-box;box-sizing:border-box}.ion-color.sc-ion-textarea-ios-h{background:initial}.ion-color.sc-ion-textarea-ios-h{color:var(--ion-color-base)}ion-item.sc-ion-textarea-ios-h,ion-item .sc-ion-textarea-ios-h{-ms-flex-item-align:baseline;align-self:baseline}ion-item.sc-ion-textarea-ios-h:not(.item-label),ion-item:not(.item-label) .sc-ion-textarea-ios-h{--padding-start:0}.textarea-wrapper.sc-ion-textarea-ios{min-width:inherit;max-width:inherit;min-height:inherit;max-height:inherit}.native-textarea.sc-ion-textarea-ios{border-radius:var(--border-radius);margin-left:0;margin-right:0;margin-top:0;margin-bottom:0;padding-left:var(--padding-start);padding-right:var(--padding-end);padding-top:var(--padding-top);padding-bottom:var(--padding-bottom);font-family:inherit;font-size:inherit;font-style:inherit;font-weight:inherit;letter-spacing:inherit;text-decoration:inherit;text-indent:inherit;text-overflow:inherit;text-transform:inherit;text-align:inherit;white-space:inherit;color:inherit;display:block;width:100%;max-width:100%;max-height:100%;border:0;outline:none;background:transparent;-webkit-box-sizing:border-box;box-sizing:border-box;resize:none;-webkit-appearance:none;-moz-appearance:none;appearance:none}@supports ((-webkit-margin-start: 0) or (margin-inline-start: 0)) or (-webkit-margin-start: 0){.native-textarea.sc-ion-textarea-ios{padding-left:unset;padding-right:unset;-webkit-padding-start:var(--padding-start);padding-inline-start:var(--padding-start);-webkit-padding-end:var(--padding-end);padding-inline-end:var(--padding-end)}}.native-textarea.sc-ion-textarea-ios::-webkit-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-ios::-moz-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-ios:-ms-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-ios::-ms-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-ios::placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea[disabled].sc-ion-textarea-ios{opacity:0.4}.cloned-input.sc-ion-textarea-ios{left:0;top:0;position:absolute;pointer-events:none}[dir=rtl].sc-ion-textarea-ios .cloned-input.sc-ion-textarea-ios,[dir=rtl].sc-ion-textarea-ios-h .cloned-input.sc-ion-textarea-ios,[dir=rtl] .sc-ion-textarea-ios-h .cloned-input.sc-ion-textarea-ios{left:unset;right:unset;right:0}.sc-ion-textarea-ios-h{--padding-top:10px;--padding-end:10px;--padding-bottom:10px;--padding-start:0;font-size:inherit}.item-label-stacked.sc-ion-textarea-ios-h,.item-label-stacked .sc-ion-textarea-ios-h,.item-label-floating.sc-ion-textarea-ios-h,.item-label-floating .sc-ion-textarea-ios-h{--padding-top:8px;--padding-bottom:8px;--padding-start:0px}";

const textareaMdCss = ".sc-ion-textarea-md-h{--background:initial;--color:initial;--placeholder-color:initial;--placeholder-font-style:initial;--placeholder-font-weight:initial;--placeholder-opacity:.5;--padding-top:0;--padding-end:0;--padding-bottom:0;--padding-start:0;--border-radius:0;display:block;position:relative;-ms-flex:1;flex:1;width:100%;background:var(--background);color:var(--color);font-family:var(--ion-font-family, inherit);white-space:pre-wrap;z-index:2;-webkit-box-sizing:border-box;box-sizing:border-box}.ion-color.sc-ion-textarea-md-h{background:initial}.ion-color.sc-ion-textarea-md-h{color:var(--ion-color-base)}ion-item.sc-ion-textarea-md-h,ion-item .sc-ion-textarea-md-h{-ms-flex-item-align:baseline;align-self:baseline}ion-item.sc-ion-textarea-md-h:not(.item-label),ion-item:not(.item-label) .sc-ion-textarea-md-h{--padding-start:0}.textarea-wrapper.sc-ion-textarea-md{min-width:inherit;max-width:inherit;min-height:inherit;max-height:inherit}.native-textarea.sc-ion-textarea-md{border-radius:var(--border-radius);margin-left:0;margin-right:0;margin-top:0;margin-bottom:0;padding-left:var(--padding-start);padding-right:var(--padding-end);padding-top:var(--padding-top);padding-bottom:var(--padding-bottom);font-family:inherit;font-size:inherit;font-style:inherit;font-weight:inherit;letter-spacing:inherit;text-decoration:inherit;text-indent:inherit;text-overflow:inherit;text-transform:inherit;text-align:inherit;white-space:inherit;color:inherit;display:block;width:100%;max-width:100%;max-height:100%;border:0;outline:none;background:transparent;-webkit-box-sizing:border-box;box-sizing:border-box;resize:none;-webkit-appearance:none;-moz-appearance:none;appearance:none}@supports ((-webkit-margin-start: 0) or (margin-inline-start: 0)) or (-webkit-margin-start: 0){.native-textarea.sc-ion-textarea-md{padding-left:unset;padding-right:unset;-webkit-padding-start:var(--padding-start);padding-inline-start:var(--padding-start);-webkit-padding-end:var(--padding-end);padding-inline-end:var(--padding-end)}}.native-textarea.sc-ion-textarea-md::-webkit-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-md::-moz-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-md:-ms-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-md::-ms-input-placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea.sc-ion-textarea-md::placeholder{padding-left:0;padding-right:0;padding-top:0;padding-bottom:0;color:var(--placeholder-color);font-family:inherit;font-style:var(--placeholder-font-style);font-weight:var(--placeholder-font-weight);opacity:var(--placeholder-opacity)}.native-textarea[disabled].sc-ion-textarea-md{opacity:0.4}.cloned-input.sc-ion-textarea-md{left:0;top:0;position:absolute;pointer-events:none}[dir=rtl].sc-ion-textarea-md .cloned-input.sc-ion-textarea-md,[dir=rtl].sc-ion-textarea-md-h .cloned-input.sc-ion-textarea-md,[dir=rtl] .sc-ion-textarea-md-h .cloned-input.sc-ion-textarea-md{left:unset;right:unset;right:0}.sc-ion-textarea-md-h{--padding-top:10px;--padding-end:0;--padding-bottom:11px;--padding-start:8px;margin-left:0;margin-right:0;margin-top:8px;margin-bottom:0;font-size:inherit}.item-label-stacked.sc-ion-textarea-md-h,.item-label-stacked .sc-ion-textarea-md-h,.item-label-floating.sc-ion-textarea-md-h,.item-label-floating .sc-ion-textarea-md-h{--padding-top:8px;--padding-bottom:8px;--padding-start:0}";

const Textarea = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.ionChange = createEvent(this, "ionChange", 7);
        this.ionInput = createEvent(this, "ionInput", 7);
        this.ionStyle = createEvent(this, "ionStyle", 7);
        this.ionBlur = createEvent(this, "ionBlur", 7);
        this.ionFocus = createEvent(this, "ionFocus", 7);
        this.inputId = `ion-textarea-${textareaIds++}`;
        this.didBlurAfterEdit = false;
        /**
         * This is required for a WebKit bug which requires us to
         * blur and focus an input to properly focus the input in
         * an item with delegatesFocus. It will no longer be needed
         * with iOS 14.
         *
         * @internal
         */
        this.fireFocusEvents = true;
        this.hasFocus = false;
        /**
         * Indicates whether and how the text value should be automatically capitalized as it is entered/edited by the user.
         */
        this.autocapitalize = 'none';
        /**
         * This Boolean attribute lets you specify that a form control should have input focus when the page loads.
         */
        this.autofocus = false;
        /**
         * If `true`, the value will be cleared after focus upon edit. Defaults to `true` when `type` is `"password"`, `false` for all other types.
         */
        this.clearOnEdit = false;
        /**
         * Set the amount of time, in milliseconds, to wait to trigger the `ionChange` event after each keystroke.
         */
        this.debounce = 0;
        /**
         * If `true`, the user cannot interact with the textarea.
         */
        this.disabled = false;
        /**
         * The name of the control, which is submitted with the form data.
         */
        this.name = this.inputId;
        /**
         * If `true`, the user cannot modify the value.
         */
        this.readonly = false;
        /**
         * If `true`, the user must fill in a value before submitting a form.
         */
        this.required = false;
        /**
         * If `true`, the element will have its spelling and grammar checked.
         */
        this.spellcheck = false;
        /**
         * If `true`, the element height will increase based on the value.
         */
        this.autoGrow = false;
        /**
         * The value of the textarea.
         */
        this.value = '';
        this.onInput = (ev) => {
            if (this.nativeInput) {
                this.value = this.nativeInput.value;
            }
            this.emitStyle();
            this.ionInput.emit(ev);
        };
        this.onFocus = (ev) => {
            this.hasFocus = true;
            this.focusChange();
            if (this.fireFocusEvents) {
                this.ionFocus.emit(ev);
            }
        };
        this.onBlur = (ev) => {
            this.hasFocus = false;
            this.focusChange();
            if (this.fireFocusEvents) {
                this.ionBlur.emit(ev);
            }
        };
        this.onKeyDown = () => {
            this.checkClearOnEdit();
        };
    }
    debounceChanged() {
        this.ionChange = debounceEvent(this.ionChange, this.debounce);
    }
    disabledChanged() {
        this.emitStyle();
    }
    /**
     * Update the native input element when the value changes
     */
    valueChanged() {
        const nativeInput = this.nativeInput;
        const value = this.getValue();
        if (nativeInput && nativeInput.value !== value) {
            nativeInput.value = value;
        }
        this.runAutoGrow();
        this.emitStyle();
        this.ionChange.emit({ value });
    }
    connectedCallback() {
        this.emitStyle();
        this.debounceChanged();
        {
            document.dispatchEvent(new CustomEvent('ionInputDidLoad', {
                detail: this.el
            }));
        }
    }
    disconnectedCallback() {
        {
            document.dispatchEvent(new CustomEvent('ionInputDidUnload', {
                detail: this.el
            }));
        }
    }
    componentDidLoad() {
        raf(() => this.runAutoGrow());
    }
    runAutoGrow() {
        const nativeInput = this.nativeInput;
        if (nativeInput && this.autoGrow) {
            readTask(() => {
                nativeInput.style.height = 'auto';
                nativeInput.style.height = nativeInput.scrollHeight + 'px';
                if (this.textareaWrapper) {
                    this.textareaWrapper.style.height = nativeInput.scrollHeight + 'px';
                }
            });
        }
    }
    /**
     * Sets focus on the native `textarea` in `ion-textarea`. Use this method instead of the global
     * `textarea.focus()`.
     */
    async setFocus() {
        if (this.nativeInput) {
            this.nativeInput.focus();
        }
    }
    /**
     * Sets blur on the native `textarea` in `ion-textarea`. Use this method instead of the global
     * `textarea.blur()`.
     * @internal
     */
    async setBlur() {
        if (this.nativeInput) {
            this.nativeInput.blur();
        }
    }
    /**
     * Returns the native `<textarea>` element used under the hood.
     */
    getInputElement() {
        return Promise.resolve(this.nativeInput);
    }
    emitStyle() {
        this.ionStyle.emit({
            'interactive': true,
            'textarea': true,
            'input': true,
            'interactive-disabled': this.disabled,
            'has-placeholder': this.placeholder != null,
            'has-value': this.hasValue(),
            'has-focus': this.hasFocus
        });
    }
    /**
     * Check if we need to clear the text input if clearOnEdit is enabled
     */
    checkClearOnEdit() {
        if (!this.clearOnEdit) {
            return;
        }
        // Did the input value change after it was blurred and edited?
        if (this.didBlurAfterEdit && this.hasValue()) {
            // Clear the input
            this.value = '';
        }
        // Reset the flag
        this.didBlurAfterEdit = false;
    }
    focusChange() {
        // If clearOnEdit is enabled and the input blurred but has a value, set a flag
        if (this.clearOnEdit && !this.hasFocus && this.hasValue()) {
            this.didBlurAfterEdit = true;
        }
        this.emitStyle();
    }
    hasValue() {
        return this.getValue() !== '';
    }
    getValue() {
        return this.value || '';
    }
    render() {
        const mode = getIonMode(this);
        const value = this.getValue();
        const labelId = this.inputId + '-lbl';
        const label = findItemLabel(this.el);
        if (label) {
            label.id = labelId;
        }
        return (h(Host, { "aria-disabled": this.disabled ? 'true' : null, class: createColorClasses(this.color, {
                [mode]: true,
            }) }, h("div", { class: "textarea-wrapper", ref: el => this.textareaWrapper = el }, h("textarea", { class: "native-textarea", "aria-labelledby": labelId, ref: el => this.nativeInput = el, autoCapitalize: this.autocapitalize, autoFocus: this.autofocus, enterKeyHint: this.enterkeyhint, inputMode: this.inputmode, disabled: this.disabled, maxLength: this.maxlength, minLength: this.minlength, name: this.name, placeholder: this.placeholder || '', readOnly: this.readonly, required: this.required, spellcheck: this.spellcheck, cols: this.cols, rows: this.rows, wrap: this.wrap, onInput: this.onInput, onBlur: this.onBlur, onFocus: this.onFocus, onKeyDown: this.onKeyDown }, value))));
    }
    get el() { return getElement(this); }
    static get watchers() { return {
        "debounce": ["debounceChanged"],
        "disabled": ["disabledChanged"],
        "value": ["valueChanged"]
    }; }
};
let textareaIds = 0;
Textarea.style = {
    ios: textareaIosCss,
    md: textareaMdCss
};

const starRatingCss = "@charset \"UTF-8\";@-webkit-keyframes fade{0%{opacity:0}100%{opacity:1}}@keyframes fade{0%{opacity:0}100%{opacity:1}}@-webkit-keyframes corner-expand{0%{width:0;opacity:0}100%{width:20px;opacity:1}}@keyframes corner-expand{0%{width:0;opacity:0}100%{width:20px;opacity:1}}@-webkit-keyframes slide-right{0%{opacity:0;-webkit-transform:translateX(-200px);transform:translateX(-200px)}}@keyframes slide-right{0%{opacity:0;-webkit-transform:translateX(-200px);transform:translateX(-200px)}}@keyframes bounce2{0%,20%,50%,80%,100%{-webkit-transform:translateY(0);transform:translateY(0)}40%{-webkit-transform:translateY(-20px);transform:translateY(-20px)}60%{-webkit-transform:translateY(-10px);transform:translateY(-10px)}}@-webkit-keyframes bounce2{0%,20%,50%,80%,100%{-webkit-transform:translateY(0);transform:translateY(0)}40%{-webkit-transform:translateY(-20px);transform:translateY(-20px)}60%{-webkit-transform:translateY(-10px);transform:translateY(-10px)}}@-webkit-keyframes heartbeat{from{-webkit-transform:scale(1);transform:scale(1);-webkit-transform-origin:center center;transform-origin:center center;-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}8%{-webkit-transform:scale(0.94);transform:scale(0.94);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}14%{-webkit-transform:scale(0.98);transform:scale(0.98);-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}28%{-webkit-transform:scale(0.92);transform:scale(0.92);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}40%{-webkit-transform:scale(1);transform:scale(1);-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}}@keyframes heartbeat{from{-webkit-transform:scale(1);transform:scale(1);-webkit-transform-origin:center center;transform-origin:center center;-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}8%{-webkit-transform:scale(0.94);transform:scale(0.94);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}14%{-webkit-transform:scale(0.98);transform:scale(0.98);-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}28%{-webkit-transform:scale(0.92);transform:scale(0.92);-webkit-animation-timing-function:ease-in;animation-timing-function:ease-in}40%{-webkit-transform:scale(1);transform:scale(1);-webkit-animation-timing-function:ease-out;animation-timing-function:ease-out}}:root{--ion-color-primary:#00b7b3;--ion-color-primary-rgb:0, 183, 179;--ion-color-primary-contrast:#ffffff;--ion-color-primary-contrast-rgb:255, 255, 255;--ion-color-primary-shade:#00a19e;--ion-color-primary-tint:#1abebb;--ion-color-secondary:#00B1D0;--ion-color-secondary-rgb:0, 177, 208;--ion-color-secondary-contrast:#ffffff;--ion-color-secondary-contrast-rgb:255, 255, 255;--ion-color-secondary-shade:#009cb7;--ion-color-secondary-tint:#1ab9d5;--ion-color-tertiary:#3b3f3f;--ion-color-tertiary-rgb:76, 110, 121;--ion-color-tertiary-contrast:#ffffff;--ion-color-tertiary-contrast-rgb:255, 255, 255;--ion-color-tertiary-shade:#343737;--ion-color-tertiary-tint:#4f5252;--ion-color-success:#10dc60;--ion-color-success-rgb:16, 220, 96;--ion-color-success-contrast:#fff;--ion-color-success-contrast-rgb:255, 255, 255;--ion-color-success-shade:#0ec254;--ion-color-success-tint:#28e070;--ion-color-warning:#ffce00;--ion-color-warning-rgb:255, 206, 0;--ion-color-warning-contrast:#000;--ion-color-warning-contrast-rgb:0, 0, 0;--ion-color-warning-shade:#e0b500;--ion-color-warning-tint:#ffd31a;--ion-color-danger:#f53d3d;--ion-color-danger-rgb:245, 61, 61;--ion-color-danger-contrast:#fff;--ion-color-danger-contrast-rgb:255, 255, 255;--ion-color-danger-shade:#d83636;--ion-color-danger-tint:#f65050;--ion-color-light:#fdfdfd;--ion-color-light-rgb:244, 244, 244;--ion-color-light-contrast:#000;--ion-color-light-contrast-rgb:0, 0, 0;--ion-color-light-shade:#d7d7d7;--ion-color-light-tint:#f5f5f5;--ion-color-medium:#989aa2;--ion-color-medium-rgb:152, 154, 162;--ion-color-medium-contrast:#000;--ion-color-medium-contrast-rgb:0, 0, 0;--ion-color-medium-shade:#86888f;--ion-color-medium-tint:#a2a4ab;--ion-color-dark:#222;--ion-color-dark-rgb:34, 34, 34;--ion-color-dark-contrast:#fff;--ion-color-dark-contrast-rgb:255, 255, 255;--ion-color-dark-shade:#1e1e1e;--ion-color-dark-tint:#383838;--ion-color-mainPlaces:#c06457;--ion-color-mainPlaces-rgb:192, 100, 87;--ion-color-mainPlaces-contrast:#ffffff;--ion-color-mainPlaces-contrast-rgb:255, 255, 255;--ion-color-mainPlaces-shade:#a9584d;--ion-color-mainPlaces-tint:#c67468;--ion-color-aroundPlaces:#222;--ion-color-aroundPlaces-rgb:34, 34, 34;--ion-color-aroundPlaces-contrast:#fff;--ion-color-aroundPlaces-contrast-rgb:255, 255, 255;--ion-color-aroundPlaces-shade:#1e1e1e;--ion-color-aroundPlaces-tint:#383838;--ion-toolbar-md-background-color:var(--ion-color-primary);--ion-toolbar-md-text-color:#fff;--ion-color-gold:#b9b029}body{margin:0px !important;padding:0px;font-family:\"Raleway\", serif}.hidden{opacity:0}.heartbeat-button{-webkit-animation:heartbeat 1.5s ease-in-out infinite both;animation:heartbeat 1.5s ease-in-out infinite both}p,h1,h2,h3,h4,h5,h6{font-family:\"Open Sans\", serif}.title{text-transform:uppercase;font-size:1.2em;font-weight:600}.center-all{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center}.star{position:relative;width:22px;height:20px;display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;}.star svg,.star i{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;position:absolute;top:0;left:0;width:100%;height:100%;font-style:normal}.star svg.star-half,.star i.star-half,.star svg.star-filled,.star i.star-filled{opacity:0}.star i{top:1px;display:none}.star.icon i,.rating.star-icon i{font-size:25px;line-height:25px}.star.icon i.star-empty:before,.rating.star-icon i.star-empty:before{content:\"☆\"}.star.icon i.star-half:before,.rating.star-icon i.star-half:before{content:\"★\"}.star.icon i.star-filled:before,.rating.star-icon i.star-filled:before{content:\"★\"}.star.custom-icon i,.rating.star-custom-icon i{font-size:18px;line-height:18px}.star.empty svg.star-half,.rating.hover:hover.value-1.half .star-container .star svg.star-half,.rating.hover:hover.hover-1 .star-container .star svg.star-half,.rating.hover:hover.value-2.half .star-container .star svg.star-half,.rating.hover:hover.hover-2 .star-container .star svg.star-half,.rating.hover:hover.value-3.half .star-container .star svg.star-half,.rating.hover:hover.hover-3 .star-container .star svg.star-half,.rating.hover:hover.value-4.half .star-container .star svg.star-half,.rating.hover:hover.hover-4 .star-container .star svg.star-half,.rating.hover:hover.value-5.half .star-container .star svg.star-half,.rating.hover:hover.hover-5 .star-container .star svg.star-half,.rating.hover:hover.value-6.half .star-container .star svg.star-half,.rating.hover:hover.hover-6 .star-container .star svg.star-half,.star.empty i.star-half,.rating.hover:hover.value-1.half .star-container .star i.star-half,.rating.hover:hover.hover-1 .star-container .star i.star-half,.rating.hover:hover.value-2.half .star-container .star i.star-half,.rating.hover:hover.hover-2 .star-container .star i.star-half,.rating.hover:hover.value-3.half .star-container .star i.star-half,.rating.hover:hover.hover-3 .star-container .star i.star-half,.rating.hover:hover.value-4.half .star-container .star i.star-half,.rating.hover:hover.hover-4 .star-container .star i.star-half,.rating.hover:hover.value-5.half .star-container .star i.star-half,.rating.hover:hover.hover-5 .star-container .star i.star-half,.rating.hover:hover.value-6.half .star-container .star i.star-half,.rating.hover:hover.hover-6 .star-container .star i.star-half,.star.empty svg.star-filled,.rating.hover:hover.value-1.half .star-container .star svg.star-filled,.rating.hover:hover.hover-1 .star-container .star svg.star-filled,.rating.hover:hover.value-2.half .star-container .star svg.star-filled,.rating.hover:hover.hover-2 .star-container .star svg.star-filled,.rating.hover:hover.value-3.half .star-container .star svg.star-filled,.rating.hover:hover.hover-3 .star-container .star svg.star-filled,.rating.hover:hover.value-4.half .star-container .star svg.star-filled,.rating.hover:hover.hover-4 .star-container .star svg.star-filled,.rating.hover:hover.value-5.half .star-container .star svg.star-filled,.rating.hover:hover.hover-5 .star-container .star svg.star-filled,.rating.hover:hover.value-6.half .star-container .star svg.star-filled,.rating.hover:hover.hover-6 .star-container .star svg.star-filled,.star.empty i.star-filled,.rating.hover:hover.value-1.half .star-container .star i.star-filled,.rating.hover:hover.hover-1 .star-container .star i.star-filled,.rating.hover:hover.value-2.half .star-container .star i.star-filled,.rating.hover:hover.hover-2 .star-container .star i.star-filled,.rating.hover:hover.value-3.half .star-container .star i.star-filled,.rating.hover:hover.hover-3 .star-container .star i.star-filled,.rating.hover:hover.value-4.half .star-container .star i.star-filled,.rating.hover:hover.hover-4 .star-container .star i.star-filled,.rating.hover:hover.value-5.half .star-container .star i.star-filled,.rating.hover:hover.hover-5 .star-container .star i.star-filled,.rating.hover:hover.value-6.half .star-container .star i.star-filled,.rating.hover:hover.hover-6 .star-container .star i.star-filled{opacity:0}.star.empty svg.star-empty,.rating.hover:hover.value-1.half .star-container .star svg.star-empty,.rating.hover:hover.hover-1 .star-container .star svg.star-empty,.rating.hover:hover.value-2.half .star-container .star svg.star-empty,.rating.hover:hover.hover-2 .star-container .star svg.star-empty,.rating.hover:hover.value-3.half .star-container .star svg.star-empty,.rating.hover:hover.hover-3 .star-container .star svg.star-empty,.rating.hover:hover.value-4.half .star-container .star svg.star-empty,.rating.hover:hover.hover-4 .star-container .star svg.star-empty,.rating.hover:hover.value-5.half .star-container .star svg.star-empty,.rating.hover:hover.hover-5 .star-container .star svg.star-empty,.rating.hover:hover.value-6.half .star-container .star svg.star-empty,.rating.hover:hover.hover-6 .star-container .star svg.star-empty,.star.empty i.star-empty,.rating.hover:hover.value-1.half .star-container .star i.star-empty,.rating.hover:hover.hover-1 .star-container .star i.star-empty,.rating.hover:hover.value-2.half .star-container .star i.star-empty,.rating.hover:hover.hover-2 .star-container .star i.star-empty,.rating.hover:hover.value-3.half .star-container .star i.star-empty,.rating.hover:hover.hover-3 .star-container .star i.star-empty,.rating.hover:hover.value-4.half .star-container .star i.star-empty,.rating.hover:hover.hover-4 .star-container .star i.star-empty,.rating.hover:hover.value-5.half .star-container .star i.star-empty,.rating.hover:hover.hover-5 .star-container .star i.star-empty,.rating.hover:hover.value-6.half .star-container .star i.star-empty,.rating.hover:hover.hover-6 .star-container .star i.star-empty{opacity:1}.star.half svg.star-filled,.rating.value-0.half .star:nth-child(1) svg.star-filled,.rating.value-1.half .star-container .star:nth-child(2) svg.star-filled,.rating.value-2.half .star-container .star:nth-child(3) svg.star-filled,.rating.value-3.half .star-container .star:nth-child(4) svg.star-filled,.rating.value-4.half .star-container .star:nth-child(5) svg.star-filled,.rating.value-5.half .star-container .star:nth-child(6) svg.star-filled,.star.half i.star-filled,.rating.value-0.half .star:nth-child(1) i.star-filled,.rating.value-1.half .star-container .star:nth-child(2) i.star-filled,.rating.value-2.half .star-container .star:nth-child(3) i.star-filled,.rating.value-3.half .star-container .star:nth-child(4) i.star-filled,.rating.value-4.half .star-container .star:nth-child(5) i.star-filled,.rating.value-5.half .star-container .star:nth-child(6) i.star-filled,.star.half svg.star-empty,.rating.value-0.half .star:nth-child(1) svg.star-empty,.rating.value-1.half .star-container .star:nth-child(2) svg.star-empty,.rating.value-2.half .star-container .star:nth-child(3) svg.star-empty,.rating.value-3.half .star-container .star:nth-child(4) svg.star-empty,.rating.value-4.half .star-container .star:nth-child(5) svg.star-empty,.rating.value-5.half .star-container .star:nth-child(6) svg.star-empty,.star.half i.star-empty,.rating.value-0.half .star:nth-child(1) i.star-empty,.rating.value-1.half .star-container .star:nth-child(2) i.star-empty,.rating.value-2.half .star-container .star:nth-child(3) i.star-empty,.rating.value-3.half .star-container .star:nth-child(4) i.star-empty,.rating.value-4.half .star-container .star:nth-child(5) i.star-empty,.rating.value-5.half .star-container .star:nth-child(6) i.star-empty{opacity:0}.star.half svg.star-half,.rating.value-0.half .star:nth-child(1) svg.star-half,.rating.value-1.half .star-container .star:nth-child(2) svg.star-half,.rating.value-2.half .star-container .star:nth-child(3) svg.star-half,.rating.value-3.half .star-container .star:nth-child(4) svg.star-half,.rating.value-4.half .star-container .star:nth-child(5) svg.star-half,.rating.value-5.half .star-container .star:nth-child(6) svg.star-half,.star.half i.star-half,.rating.value-0.half .star:nth-child(1) i.star-half,.rating.value-1.half .star-container .star:nth-child(2) i.star-half,.rating.value-2.half .star-container .star:nth-child(3) i.star-half,.rating.value-3.half .star-container .star:nth-child(4) i.star-half,.rating.value-4.half .star-container .star:nth-child(5) i.star-half,.rating.value-5.half .star-container .star:nth-child(6) i.star-half{opacity:1}.star.filled svg.star-empty,.rating.value-6 .star-container .star:nth-child(-n+6) svg.star-empty,.rating.value-7 .star-container .star:nth-child(-n+7) svg.star-empty,.rating.value-8 .star-container .star:nth-child(-n+8) svg.star-empty,.rating.value-9 .star-container .star:nth-child(-n+9) svg.star-empty,.rating.value-10 .star-container .star:nth-child(-n+10) svg.star-empty,.rating.value-11 .star-container .star:nth-child(-n+11) svg.star-empty,.rating.value-12 .star-container .star:nth-child(-n+12) svg.star-empty,.rating.value-1 .star-container .star:nth-child(-n+1) svg.star-empty,.rating.value-2 .star-container .star:nth-child(-n+2) svg.star-empty,.rating.value-3 .star-container .star:nth-child(-n+3) svg.star-empty,.rating.value-4 .star-container .star:nth-child(-n+4) svg.star-empty,.rating.value-5 .star-container .star:nth-child(-n+5) svg.star-empty,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) svg.star-empty,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) svg.star-empty,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) svg.star-empty,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) svg.star-empty,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) svg.star-empty,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) svg.star-empty,.star.filled i.star-empty,.rating.value-6 .star-container .star:nth-child(-n+6) i.star-empty,.rating.value-7 .star-container .star:nth-child(-n+7) i.star-empty,.rating.value-8 .star-container .star:nth-child(-n+8) i.star-empty,.rating.value-9 .star-container .star:nth-child(-n+9) i.star-empty,.rating.value-10 .star-container .star:nth-child(-n+10) i.star-empty,.rating.value-11 .star-container .star:nth-child(-n+11) i.star-empty,.rating.value-12 .star-container .star:nth-child(-n+12) i.star-empty,.rating.value-1 .star-container .star:nth-child(-n+1) i.star-empty,.rating.value-2 .star-container .star:nth-child(-n+2) i.star-empty,.rating.value-3 .star-container .star:nth-child(-n+3) i.star-empty,.rating.value-4 .star-container .star:nth-child(-n+4) i.star-empty,.rating.value-5 .star-container .star:nth-child(-n+5) i.star-empty,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) i.star-empty,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) i.star-empty,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) i.star-empty,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) i.star-empty,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) i.star-empty,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) i.star-empty,.star.filled svg.star-filled,.rating.value-6 .star-container .star:nth-child(-n+6) svg.star-filled,.rating.value-7 .star-container .star:nth-child(-n+7) svg.star-filled,.rating.value-8 .star-container .star:nth-child(-n+8) svg.star-filled,.rating.value-9 .star-container .star:nth-child(-n+9) svg.star-filled,.rating.value-10 .star-container .star:nth-child(-n+10) svg.star-filled,.rating.value-11 .star-container .star:nth-child(-n+11) svg.star-filled,.rating.value-12 .star-container .star:nth-child(-n+12) svg.star-filled,.rating.value-1 .star-container .star:nth-child(-n+1) svg.star-filled,.rating.value-2 .star-container .star:nth-child(-n+2) svg.star-filled,.rating.value-3 .star-container .star:nth-child(-n+3) svg.star-filled,.rating.value-4 .star-container .star:nth-child(-n+4) svg.star-filled,.rating.value-5 .star-container .star:nth-child(-n+5) svg.star-filled,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) svg.star-filled,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) svg.star-filled,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) svg.star-filled,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) svg.star-filled,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) svg.star-filled,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) svg.star-filled,.star.filled i.star-filled,.rating.value-6 .star-container .star:nth-child(-n+6) i.star-filled,.rating.value-7 .star-container .star:nth-child(-n+7) i.star-filled,.rating.value-8 .star-container .star:nth-child(-n+8) i.star-filled,.rating.value-9 .star-container .star:nth-child(-n+9) i.star-filled,.rating.value-10 .star-container .star:nth-child(-n+10) i.star-filled,.rating.value-11 .star-container .star:nth-child(-n+11) i.star-filled,.rating.value-12 .star-container .star:nth-child(-n+12) i.star-filled,.rating.value-1 .star-container .star:nth-child(-n+1) i.star-filled,.rating.value-2 .star-container .star:nth-child(-n+2) i.star-filled,.rating.value-3 .star-container .star:nth-child(-n+3) i.star-filled,.rating.value-4 .star-container .star:nth-child(-n+4) i.star-filled,.rating.value-5 .star-container .star:nth-child(-n+5) i.star-filled,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) i.star-filled,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) i.star-filled,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) i.star-filled,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) i.star-filled,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) i.star-filled,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) i.star-filled{opacity:0}.star.filled svg.star-filled,.rating.value-6 .star-container .star:nth-child(-n+6) svg.star-filled,.rating.value-7 .star-container .star:nth-child(-n+7) svg.star-filled,.rating.value-8 .star-container .star:nth-child(-n+8) svg.star-filled,.rating.value-9 .star-container .star:nth-child(-n+9) svg.star-filled,.rating.value-10 .star-container .star:nth-child(-n+10) svg.star-filled,.rating.value-11 .star-container .star:nth-child(-n+11) svg.star-filled,.rating.value-12 .star-container .star:nth-child(-n+12) svg.star-filled,.rating.value-1 .star-container .star:nth-child(-n+1) svg.star-filled,.rating.value-2 .star-container .star:nth-child(-n+2) svg.star-filled,.rating.value-3 .star-container .star:nth-child(-n+3) svg.star-filled,.rating.value-4 .star-container .star:nth-child(-n+4) svg.star-filled,.rating.value-5 .star-container .star:nth-child(-n+5) svg.star-filled,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) svg.star-filled,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) svg.star-filled,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) svg.star-filled,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) svg.star-filled,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) svg.star-filled,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) svg.star-filled,.star.filled i.star-filled,.rating.value-6 .star-container .star:nth-child(-n+6) i.star-filled,.rating.value-7 .star-container .star:nth-child(-n+7) i.star-filled,.rating.value-8 .star-container .star:nth-child(-n+8) i.star-filled,.rating.value-9 .star-container .star:nth-child(-n+9) i.star-filled,.rating.value-10 .star-container .star:nth-child(-n+10) i.star-filled,.rating.value-11 .star-container .star:nth-child(-n+11) i.star-filled,.rating.value-12 .star-container .star:nth-child(-n+12) i.star-filled,.rating.value-1 .star-container .star:nth-child(-n+1) i.star-filled,.rating.value-2 .star-container .star:nth-child(-n+2) i.star-filled,.rating.value-3 .star-container .star:nth-child(-n+3) i.star-filled,.rating.value-4 .star-container .star:nth-child(-n+4) i.star-filled,.rating.value-5 .star-container .star:nth-child(-n+5) i.star-filled,.rating.hover:hover.hover-1 .star-container .star:nth-child(-n+1) i.star-filled,.rating.hover:hover.hover-2 .star-container .star:nth-child(-n+2) i.star-filled,.rating.hover:hover.hover-3 .star-container .star:nth-child(-n+3) i.star-filled,.rating.hover:hover.hover-4 .star-container .star:nth-child(-n+4) i.star-filled,.rating.hover:hover.hover-5 .star-container .star:nth-child(-n+5) i.star-filled,.rating.hover:hover.hover-6 .star-container .star:nth-child(-n+6) i.star-filled{opacity:1}.star.default svg,.star-container .star svg{fill:#fdd835 !important}.star.default i,.star-container .star i{color:#fdd835 !important}.star.negative svg,.rating.hover:hover.hover-1 .star-container .star svg,.rating.hover:hover.hover-2 .star-container .star svg,.rating.value-0.half .star svg{fill:#f03c56}.star.negative i,.rating.hover:hover.hover-1 .star-container .star i,.rating.hover:hover.hover-2 .star-container .star i,.rating.value-0.half .star i{color:#f03c56}.star.ok svg,.rating.hover:hover.hover-3 .star-container .star svg{fill:#ffc058}.star.ok i,.rating.hover:hover.hover-3 .star-container .star i{color:#ffc058}.star.positive svg,.rating.value-6 .star-container .star svg,.rating.value-7 .star-container .star svg,.rating.value-8 .star-container .star svg,.rating.value-9 .star-container .star svg,.rating.value-10 .star-container .star svg,.rating.value-11 .star-container .star svg,.rating.value-12 .star-container .star svg,.rating.hover:hover.hover-4 .star-container .star svg,.rating.hover:hover.hover-5 .star-container .star svg,.rating.hover:hover.hover-6 .star-container .star svg{fill:#7ed321}.star.positive i,.rating.value-6 .star-container .star i,.rating.value-7 .star-container .star i,.rating.value-8 .star-container .star i,.rating.value-9 .star-container .star i,.rating.value-10 .star-container .star i,.rating.value-11 .star-container .star i,.rating.value-12 .star-container .star i,.rating.hover:hover.hover-4 .star-container .star i,.rating.hover:hover.hover-5 .star-container .star i,.rating.hover:hover.hover-6 .star-container .star i{color:#7ed321}.star.svg i,.rating.star-svg i{display:none}.star.svg svg,.rating.star-svg svg{display:-ms-flexbox;display:flex}.star.custom-icon svg,.rating.star-custom-icon svg,.star.icon svg,.rating.star-icon svg{display:none}.star.custom-icon i,.rating.star-custom-icon i,.star.icon i,.rating.star-icon i{display:-ms-flexbox;display:flex}.star.small,.rating.small .star{width:10px;height:9, 5px}.star.small i,.rating.small .star i{font-size:11px;line-height:10px}.star.medium,.rating.medium .star{width:22px;height:22px}.star.medium i,.rating.medium .star i{font-size:25px;line-height:25px}.star.large,.rating.large .star{width:35px;height:33.3px}.star.large i,.rating.large .star i{font-size:36px;line-height:35px}.star.disabled,.rating.disabled .star-container .star{opacity:0.5}.star.direction-rtl svg.star-half,.rating.direction-rtl .star-container .star svg.star-half,.star-container.direction-rtl .star svg.star-half,.star.direction-rtl i.star-half,.rating.direction-rtl .star-container .star i.star-half,.star-container.direction-rtl .star i.star-half{-webkit-transform:scale(-1, 1);transform:scale(-1, 1)}.star.direction-ltr svg.star-half,.star-container.direction-ltr .star svg.star-half,.star.direction-ltr i.star-half,.star-container.direction-ltr .star i.star-half{-webkit-transform:scale(1, 1);transform:scale(1, 1)}.label-value{font-size:18px;line-height:18px;}.label-value.small,.rating.small .label-value{font-size:9.5px;line-height:9.5px}.label-value.medium,.rating.medium .label-value{font-size:18px;line-height:25px}.label-value.large,.rating.large .label-value{font-size:28px;line-height:35px}.label-value.disabled,.rating.disabled .label-value{opacity:0.5}.star-container{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex:0 0 auto;flex:0 0 auto;-ms-flex-pack:center;justify-content:center;margin-left:5px;margin-right:5px;-webkit-transition:all 0.3s ease;transition:all 0.3s ease;}.star-container+.star{margin-left:5px}.star-container .star{-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.star-container .star svg,.star-container .star i{-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.star-container svg{z-index:2}.star-container i{z-index:1}.star-container.direction-rtl{direction:rtl}.star-container.direction-ltr{direction:ltr}.star-container.space-no,.rating.space-no .star-container{-ms-flex:1 1 auto;flex:1 1 auto;-ms-flex-pack:center;justify-content:center}.star-container.space-between,.rating.space-between .star-container{-ms-flex:1 1 auto;flex:1 1 auto;-ms-flex-pack:justify;justify-content:space-between}.star-container.space-around,.rating.space-around .star-container{-ms-flex:1 1 auto;flex:1 1 auto;-ms-flex-pack:distribute;justify-content:space-around}.rating{display:-ms-flexbox;display:flex;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;margin-bottom:5px;}.rating.value-1 .star-container .star svg{fill:#f03c56}.rating.value-1 .star-container .star i{color:#f03c56}.rating.value-2 .star-container .star svg{fill:#f03c56}.rating.value-2 .star-container .star i{color:#f03c56}.rating.value-3 .star-container .star svg{fill:#ffc058}.rating.value-3 .star-container .star i{color:#ffc058}.rating.value-4 .star-container .star svg{fill:#7ed321}.rating.value-4 .star-container .star i{color:#7ed321}.rating.value-5 .star-container .star svg{fill:#7ed321}.rating.value-5 .star-container .star i{color:#7ed321}.rating.value-6 .star-container .star svg{fill:#7ed321}.rating.value-6 .star-container .star i{color:#7ed321}.rating.label-hidden .label-value{display:none}.rating.label-visible{display:-ms-flexbox;display:flex}.rating.label-top{-ms-flex-direction:column;flex-direction:column}.rating.label-top .label-value+.star-container{margin-left:0;margin-right:0;margin-top:5px}.rating.label-left .label-value{-ms-flex:0 0 auto;flex:0 0 auto}.rating.label-left .label-value+.star-container{margin-left:5px;margin-right:0}.rating.label-right{-ms-flex-direction:row-reverse;flex-direction:row-reverse}.rating.label-right .label-value+.star-container{margin-left:0;margin-right:5px}.rating.label-bottom{-ms-flex-direction:column-reverse;flex-direction:column-reverse}.rating.label-bottom .label-value+.star-container{margin-left:0;margin-right:0;margin-bottom:5px}.rating.direction-rtl,.star-container.direction-rtl .star.rating{direction:rtl}.rating.direction-ltr,.star-container.direction-ltr .star.rating{direction:ltr}.rating.color-default .star-container .star svg{fill:#fdd835 !important}.rating.color-default .star-container .star i{color:#fdd835 !important}.rating.color-ok .star-container .star svg{fill:#ffc058 !important}.rating.color-ok .star-container .star i{color:#ffc058 !important}.rating.color-positive .star-container .star svg{fill:#7ed321 !important}.rating.color-positive .star-container .star i{color:#7ed321 !important}.rating.color-negative .star-container .star svg{fill:#f03c56 !important}.rating.color-negative .star-container .star i{color:#f03c56 !important}.rating.immediately .star-container{-webkit-transition:all none;transition:all none}.rating.immediately .star-container .star{-webkit-transition:none;transition:none}.rating.immediately .star-container .star svg,.rating.immediately .star-container .star i{-webkit-transition:none;transition:none}.rating.noticeable .star-container{-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.rating.noticeable .star-container .star{-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.rating.noticeable .star-container .star svg,.rating.noticeable .star-container .star i{-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.rating.slow .star-container{-webkit-transition:all 0.8s ease;transition:all 0.8s ease}.rating.slow .star-container .star{-webkit-transition:all 0.8s ease;transition:all 0.8s ease}.rating.slow .star-container .star svg,.rating.slow .star-container .star i{-webkit-transition:all 0.8s ease;transition:all 0.8s ease}star-rating .light-star{color:white !important}star-rating .colored-star{color:#FDD835 !important}";

const StarRating = class {
    constructor(hostRef) {
        registerInstance(this, hostRef);
        this.ratingChanged = createEvent(this, "ratingChanged", 7);
        // Props
        this.light = false; // If true the stars should be all white
        // Internal variables
        this.starIndexes = [1, 2, 3, 4, 5];
    }
    ////////////////////////////////////////////////////////////////
    // Life Cycle
    ////////////////////////////////////////////////////////////////
    /**
     * Override
     */
    componentWillLoad() {
        this.rating = 0;
    }
    ////////////////////////////////////////////////////////////////
    // User Interactions
    ////////////////////////////////////////////////////////////////
    /**
     * The user clicks on a star
     * Emit a change
     * @param event
     */
    setRating(_rating) {
        this.rating = _rating;
        this.ratingChanged.emit(this.rating);
    }
    ////////////////////////////////////////////////////////////////
    // Render
    ////////////////////////////////////////////////////////////////
    render() {
        return (h("div", { class: 'value-' + this.rating + ' color-default rating medium star-icon direction-ltr' }, h("div", { class: 'star-container' }, this.starIndexes.map(index => h("div", { class: 'star', onClick: (e) => this.setRating(index) }, h("i", { class: 'star-empty ' + (this.light ? 'light-star' : 'colored-star') }), h("i", { class: 'star-half ' + (this.light ? 'light-star' : 'colored-star') }), h("i", { class: 'star-filled ' + (this.light ? 'light-star' : 'colored-star') }))))));
    }
};
StarRating.style = starRatingCss;

export { Textarea as ion_textarea, StarRating as star_rating };
