import 'hammerjs';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class AudioPlayer {
    private webAudioGetter;
    private progressIntervalId;
    private lastDeltaX;
    private draggingPoint;
    private howlSound;
    contentId: string;
    src: string;
    audioTitle: string;
    type: string;
    script: string;
    openTranscript: boolean;
    color: string;
    audioPlaying: boolean;
    currentProgress: number;
    currentAudioTimeFormatted: string;
    totalAudioTime: number;
    totalAudioTimeFormatted: string;
    transcriptDisplayed: boolean;
    audioPlayed: EventEmitter<boolean>;
    /**
     * Override
     */
    private componentWillLoad;
    /**
     * Interrupt audio
     */
    stopAudio(): Promise<void>;
    /**
     * The user clicks on the play/pause button
     */
    private interactWithAudio;
    /**
     * The suer wants to display the transcript
     */
    private displayTranscript;
    /**
     * Return the WebAudio component
     */
    private referenceWebAudio;
    /**
     * Setup the touch controls on the point to update the position in the audio
     */
    private setupPointControl;
    /**
     * Compute the audio currentTime progress in percentage
     * @param stopProgressUpdate whether it has to stop the progress update
     */
    private updateAudioProgress;
    /**
     * Format an audio duration into a readable format
     * composed of minutes and seconds {00:00}
     * @param length
     */
    private formatAudioTime;
    render(): any;
}
