import { MediaElement } from '../../../models/media/media-model';
import { EventEmitter } from '../../../stencil-public-runtime';
export declare class ImageGallery {
    colorMode: string;
    images: MediaElement[];
    fullScreen: boolean;
    standAlone: boolean;
    isWeb: boolean;
    isEnd: boolean;
    isBeginning: boolean;
    popupVisible: boolean;
    fullScreenRequested: EventEmitter<string>;
    closeModalClicked: EventEmitter<string>;
    checkSlidePosition(): void;
    /**
     * Override
     */
    private componentDidLoad;
    /**
     * Open the Modal
     */
    private requestFullscreen;
    /**
     * Close the Modal
    */
    private closeModal;
    /**
     * Trigger the next slide
     */
    private slideNext;
    /**
     * Trigger the previous slide
     */
    private slidePrev;
    /**
     * Get whether or not the current slide is the last slide
     */
    private isEndSlide;
    /**
     * Get whether or not the current slide is the first slide
     */
    private isBeginningSlide;
    /**
     * Get the Slides component from the DOM
     */
    private getSlides;
    /**
     * Mini images inline
     */
    private miniImages;
    /**
     * Slider
     */
    private slider;
    /**
     * Popup containing info about image
     */
    private popup;
    /**
     * Image name and year
     * @param image
     */
    private titleContainer;
    /**
     * Separator between title and description
     */
    private separator;
    /**
     * Image description
     * @param image
     */
    private descriptionContainer;
    /**
     * Image legal mentions
     * @param image
     */
    private legalContainer;
    /**
     * Previous slide button
     */
    prevButton(): any;
    /**
     * Next slide button
     */
    nextButton(): any;
    /**
     * Close button to leave fullscreen mode
     */
    closeButton(): any;
    render(): any;
}
