import { Content } from '../content/content-model';
import { Expert } from '../expert/expert-model';
import { Region } from '../region/region-model';
import { Sublist } from '../sublist/sublist-model';
import { MediaElement } from '../media/media-model';
export declare enum CompositionType {
    TOUR = 0,
    LIST = 1,
    PROGRAM = 2
}
export declare abstract class Composition {
    id?: string;
    type: number;
    name: string;
    introduction: string;
    description: string;
    price: string;
    duration: string;
    bestMoment: string;
    reasons: string[];
    images: MediaElement[];
    readonly expertRef: string;
    readonly expert: Expert;
    expertLoad: boolean;
    readonly regionRef: string;
    readonly region: Region;
    regionLoad: boolean;
    readonly sublistsRef: string[];
    readonly sublists: Sublist[];
    sublistsLoad: boolean;
    readonly contentsRef: string[];
    readonly contents: Content[];
    contentsLoad: boolean;
    constructor();
}
